=== debian/changelog ===
owncloud-client (2.11.0.8354+dfsg-1) unstable; urgency=medium

  [ Pierre-Elliott Bécue ]
  * New upstream release 2.11.0.8354+dfsg
  * d/watch: update tracking url
  * d/copyright: Updated
  * d/rules: Add variable overloading for cmake to mark this version as
    Debian-managed
  * d/control:
    - Drop owncloud-client-l10n
    - Cleans version on deps and breaks/replaces that are moot
    - Add Breaks+Replaces on owncloud-client for owncloud-client-l10n

  [ Sandro Knauß ]
  * Remove myself from Uploaders.

 -- Pierre-Elliott Bécue <peb@debian.org>  Thu, 29 Sep 2022 01:05:25 +0200
