## owncloud-client 3.2.0.10193+dfsg

=== debian/changelog ===
owncloud-client (3.2.0.10193+dfsg-1) unstable; urgency=medium

  * New upstream release 3.2.0.10193+dfsg
    - Merged patches removed the first one, using WITH_AUTO_UPDATER=OFF
      instead
  * d/rules: make dh_missing fail
  * Add a lintian-override on the dolphin-owncloud package.

 -- Pierre-Elliott Bécue <peb@debian.org>  Tue, 21 Mar 2023 01:05:13 +0100
