=== debian/control ===
--- 
+++ 
@@ -15,7 +15,9 @@
                libqt5webkit5-dev,
                libsqlite3-dev,
                libssl-dev,
+               libre-graph-api-cpp-qt-client,
                optipng,
+               pkg-config,
                python3-all,
                qt5keychain-dev,
                qtdeclarative5-dev,
