=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	dh $@ --with python3
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DUNIT_TESTING=ON -DDEBIAN_VERSION=$(DEB_VERSION) -DPLUGIN_INSTALL_DIR=/usr/lib/$(DEB_HOST_GNU_TYPE)/qt5/plugins -DAPPLICATION_VENDOR=Debian -DAPPLICATION_DOMAIN=packages.debian.org/owncloud-client
+	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DUNIT_TESTING=ON -DDEBIAN_VERSION=$(DEB_VERSION) -DPLUGIN_INSTALL_DIR=/usr/lib/$(DEB_HOST_GNU_TYPE)/qt5/plugins -DAPPLICATION_VENDOR=Debian -DAPPLICATION_DOMAIN=packages.debian.org/owncloud-client -DWITH_AUTO_UPDATER=OFF
 
 override_dh_auto_build-indep:
 	dh_auto_build -- -C shell_integration/nautilus
@@ -37,9 +37,6 @@
 	dh_auto_install -- -C shell_integration/nautilus
 	dh_auto_install --
 
-override_dh_missing:
-	dh_missing --list-missing
-
 override_dh_python3-arch:
 
 override_dh_python3:
